/*  --------------------------- N O T I C E ------------------------------
    This file has been stripped of symbolic information in order to protect
    trade secrets and protected and/or confidential source code.  This file
    remains Copyright (c) 1997 iMatix and is subject to the following terms
    and conditions in addition to the license terms agreed-on between the
    user and iMatix:
    1.  All reverse-engineering, reconstruction, or partial reuse of this
        source code is forbidden.
    2.  Any modification of this source code will consitute a violation of
        the license and guarantee terms agreed between the user and iMatix.
    3.  Distribution of this source code is allowed only according to the
        terms of the respective product license agreement.
    ---------------------------------------------------------------------- */
#include "sfl.h"
#include "formio.h"
char
*form_strerror;
RANGE
range_all = { 0, -1 },
range_none = { -1, 0 };
static FORM_ITEM
*_3757;
static SYMTAB
*_3758;
static int
_3759;
enum {
_3760 = 1,
focus_field = 2,
_3761 = 3
};
static char
*_3762 = "<TABLE><TR><TD BGCOLOR=\"#FF0000\">&gt;",
*_3763 = "</TABLE>";
static FORM_ITEM *_3764 (FORM_DEFN *defn);
static char *_3765 (byte *_3766);
static void _3767 (VDESCR *stream, byte *block, int field, int _3768);
static void _3769 (VDESCR *stream, char *source, int size);
static void _3770 (VDESCR *stream, char *source);
static void _3771 (VDESCR *stream, char *format, ...);
static void _3772 (VDESCR *stream, byte *block);
static void _3773 (VDESCR *stream, byte *block);
static void _3774 (VDESCR *stream, byte *block, int field, int _3768);
static void _3775 (VDESCR *stream, byte *block, int field, int _3768);
static void _3776 (VDESCR *stream, byte *block, int field, int _3768);
static void _3777 (VDESCR *stream, byte *block, int field, int _3768);
static void _3778 (VDESCR *stream, byte *block, int field, int _3768);
static void _3779 (VDESCR *stream, byte *block, int field, int _3768);
static void _3780 (VDESCR *stream, byte *block, int field, int _3768);
static void _3781 (VDESCR *stream, byte *block, int field, int _3768);
static void _3782 (VDESCR *stream, byte *block, int field, int _3768);
static void _3783 (VDESCR *stream, byte *block, int index);
static void _3784 (VDESCR *stream, byte *block);
static void _3785 (VDESCR *stream, char *value, int field, int _3768);
static void _3786 (byte *block, int field, int index, byte attr);
static Bool _3787 (int field);
static Bool _3788 (int field, int index);
static Bool _3789 (RANGE *range, int field);
static byte *_3790 (int field, int index);
static char *_3791 (int field, int index);
static char *_3792 (byte *block, int index);
static void _3793 (byte *block, int *flags, int *_3794, int *_3795,
int *width);
static int _3796 (byte *block, int field, int index, char *value);
static void _3797 (int field, int index);
static int _3798 (byte *block, int field, int index, char *value);
static int _3799 (byte *block, int field, int index, char *value);
static int _3800 (byte *block, int field, int index, char *value);
static int _3801 (byte *block, int field, int index, char *value);
static int _3802 (byte *block, int field, int index, char *value);
static void _3803 (SYMTAB *symtab, byte *block);
static Bool _3804 (char *value);
static char *_3805 (int field, int index, int item, char _3806);
static char *_3807 (int field, int index, int item, char _3806);
static Bool _3808 (FORM_ITEM *form, byte *_3766,
int _3809, va_list _3810);
static Bool _3811 (FORM_ITEM *form, byte *_3766,
int _3809, va_list _3810);
static Bool _3812 (FORM_ITEM *form, byte *_3766,
int _3809, va_list _3810);
static Bool _3813 (FORM_ITEM *form, byte *_3766,
int _3809, va_list _3810);
static Bool _3814 (SYMBOL *symbol, ...);
static void _3815 (SYMTAB *symtab);
#define _3816(b) ((b) [0] << 8) + ((b) [1])
#define _3817(b) ((b) [2])
#define _3818(b) ((b) [3])
#define _3819(b) ((b) [4])
#define _3820(b) ((char *) ((b) + 3))
#define _3821(b) ((b) [3])
#define _3822(b) ((b) [4] << 8) + ((b) [5])
#define _3823(b) ((b) [6] << 8) + ((b) [7])
#define _3824(b) ((b) [3] << 8) + ((b) [4])
#define _3825(b) ((b) [5] << 8) + ((b) [6])
#define _3826(b) ((b) [3] << 8) + ((b) [4])
#define _3827(b) ((b) [5] << 8) + ((b) [6])
#define _3828(b) ((b) [3] << 8) + ((b) [4])
#define _3829(b) ((b) [5] << 8) + ((b) [6])
#define _3830(b) ((b) [7] << 8) + ((b) [8])
#define _3831(b) ((b) [3])
#define _3832(b) ((b) [4])
#define _3833(b) ((b) [5])
#define _3834(b) ((b) [6] << 8) + ((b) [7])
#define _3835(b) ((b) [8] << 8) + ((b) [9])
#define _3836(b) ((char *) ((b) + 10))
#define _3837(b) (_3836 (b) + strlen (_3836 (b)) + 1)
#define _3838(b) ((b) [3])
#define _3839(b) ((b) [4])
#define _3840(b) ((b) [5] << 8) + ((b) [6])
#define _3841(b) ((b) [7] << 8) + ((b) [8])
#define _3842(b) ((char *) ((b) + 9))
#define _3843(b) (_3842 (b) + strlen (_3842 (b)) + 1)
#define _3844(b) ((b) [3])
#define _3845(b) ((b) [4])
#define _3846(b) ((b) [5] << 8) + ((b) [6])
#define _3847(b) ((b) [7] << 8) + ((b) [8])
#define _3848(b) ((b) [9])
#define _3849(b) ((b) [10])
#define _3850(b) ((b) [11])
#define _3851(b) ((b) [12])
#define _3852(b) ((b) [13])
#define _3853(b) ((b) [14])
#define _3854(b) ((char *) ((b) + 15))
#define _3855(b) (_3854 (b) + strlen (_3854 (b)) + 1)
#define _3856(b) ((b) [3])
#define _3857(b) ((b) [4])
#define _3858(b) ((b) [5] << 8) + ((b) [6])
#define _3859(b) ((b) [7])
#define _3860(b) ((b) [8])
#define _3861(b) ((b) [9])
#define _3862(b) ((b) [10])
#define _3863(b) ((b) [11])
#define _3864(b) (char *) ((b) + 12)
#define _3865(b) (_3864 (b) + strlen (_3864 (b)) + 1)
#define _3866(b) (_3865 (b) + strlen (_3865 (b)) + 1)
#define _3867(b) ((b) [3])
#define _3868(b) ((b) [4])
#define _3869(b) ((b) [5] << 8) + ((b) [6])
#define _3870(b) (char *) ((b) + 7)
#define _3871(b) (_3870 (b) + strlen (_3870 (b)) + 1)
#define _3872(b) (_3871 (b) + strlen (_3871 (b)) + 1)
#define _3873(b) ((b) [3])
#define _3874(b) ((b) [4])
#define _3875(b) ((b) [5])
#define _3876(b) ((b) [6])
#define _3877(b) ((b) [7])
#define _3878(b) ((b) [8] << 8) + ((b) [9])
#define _3879(b) ((char *) ((b) + 10))
#define _3880(b) (_3879 (b) + strlen (_3879 (b)) + 1)
#define _3881(b) ((b) [3])
#define _3882(b) ((b) [4])
#define _3883(b) ((char *) ((b) + 5))
#define _3884(b) (_3883 (b) + strlen (_3883 (b)) + 1)
#define _3885(b) (_3884 (b) + strlen (_3884 (b)) + 1)
#define _3886(b) (_3885 (b) + strlen (_3885 (b)) + 1)
#define _3887(b) ((b) [3])
#define _3888(b) ((b) [4])
#define _3889(b) ((b) [5])
#define _3890(b) ((b) [6])
#define _3891(b) ((char *) ((b) + 7))
#define _3892(b) (_3891 (b) + strlen (_3891 (b)) + 1)
#define _3893(b) (_3892 (b) + strlen (_3892 (b)) + 1)
#define _3894(b) (_3893 (b) + strlen (_3893 (b)) + 1)
#define _3895(b) ((b) [3])
#define _3896(b) ((b) [4])
#define _3897(b) ((b) [5])
#define _3898(b) ((b) [6])
#define _3899(b) ((char *) ((b) + 7))
#define _3900(b) (_3899 (b) + strlen (_3899 (b)) + 1)
#define _3901(b) (_3900 (b) + strlen (_3900 (b)) + 1)
#define _3902(b) ((b) [3] << 8) + ((b) [4])
#define _3903(b) ((b) [5])
#define _3904(b) ((char *) ((b) + 6))
#define _3905(b) ((b) [3])
#define _3906(b) ((b) [4] << 8) + ((b) [5])
#define _3907(b) ((b) [6] << 8) + ((b) [7])
#define _3908(b) ((b) [8])
#define _3909(b) ((b) [9] << 8) + ((b) [10])
#define _3910(b) ((b) [11] << 8) + ((b) [12])
#define _3911(b) ((char *) ((b) + 13))
#define _3912(b) (_3911 (b) + strlen (_3911 (b)) + 1)
#define _3913(t) ((t) == BLOCK_TEXTUAL || \
(t) == BLOCK_NUMERIC || \
(t) == BLOCK_DATE || \
(t) == BLOCK_TIME || \
(t) == BLOCK_TEXTBOX || \
(t) == BLOCK_BOOLEAN || \
(t) == BLOCK_SELECT || \
(t) == BLOCK_FILE || \
(t) == BLOCK_RADIO )
#define _3914(f) ((char *) _3757-> data + \
_3757-> defn-> fields [f].data)
#define _3915(f) (_3757-> defn-> blocks + \
_3757-> defn-> fields [f].block)
#define _3916(f) (_3757-> defn-> fields [f].max)
#define _3917(b) (_3757-> data + \
_3757-> defn-> fields_size + _3907 (b))
#define _3918 1
typedef struct {
char *input;
char *output;
int error;
int _3919;
} _3920;
static _3920 _3921 [] = {
{ "TEXT", "%s",                 0, 0 },
{ "TEXT", "%s",                 1, 0 },
{ "PASSWORD", "",               0, 0 },
{  NULL,  "%s",                 0, 0 },
{ "HIDDEN", "",                 0, 1 },
{  NULL,  "",                   0, 1 },
{  NULL, "%s",                  0, 0 },
{  NULL, "<EM>%s</EM>",         0, 0 },
{  NULL, "<STRONG>%s</STRONG>", 0, 0 },
{  NULL, "<BIG>%s</BIG>",       0, 0 },
{  NULL, "%s",                  0, 0 }
};
FORM_ITEM *
form_init (
FORM_DEFN *defn,
Bool values)
{
FORM_ITEM
*form;
ASSERT (defn);
if ((form = _3764 (defn)) == NULL)
return (NULL);
if (values)
{
form-> language = FLANG_ENGLISH;
form-> date_order = DATE_ORDER_DMY;
form-> date_sep = '/';
form-> dec_point = '.';
form-> input_range = range_all;
form-> blank_range = range_none;
form-> JavaScript = 1;
form-> focus_field = 0;
form-> focus_index = 0;
form-> click_field = 0;
form-> click_index = 0;
form_use (form);
form_exec (form, _3808);
}
return (form);
}
static FORM_ITEM *
_3764 (
FORM_DEFN *defn)
{
FORM_ITEM
*form;
MEMTRN
*_3922;
ASSERT (defn);
_3922 = mem_new_trans ();
if ((form = mem_alloc (sizeof (FORM_ITEM))) == NULL)
return (NULL);
memset (form, 0, sizeof (FORM_ITEM));
form-> defn = defn;
form-> data_size = defn-> fields_size + defn-> action_count;
form-> data = mem_alloc (form-> data_size);
if (form-> data == NULL)
{
mem_rollback (_3922);
return (NULL);
}
memset (form-> data, 0, form-> data_size);
mem_commit (_3922);
return (form);
}
static Bool
_3808 (
FORM_ITEM *form,
byte *_3766,
int _3809,
va_list _3810)
{
byte
_3923,
_3924;
char
*_3925,
*_3926;
int
_3927;
if (_3913 (_3817 (_3766)))
{
_3923 = _3819 (_3766);
_3924 = _3818 (_3766);
_3926 = _3765 (_3766);
_3925 = _3914 (_3809);
for (_3927 = 0; _3927 < _3923; _3927++)
*_3925++ = _3924;
ASSERT (strlen (_3926) <= _3916 (_3809));
for (_3927 = 0; _3927 < _3923; _3927++)
{
strcpy ((char *) _3925, _3926);
_3925 += _3916 (_3809) + 1;
}
}
else
if (_3817 (_3766) == BLOCK_ACTION)
*_3917 (_3766) = _3908 (_3766);
return (TRUE);
}
static char *
_3765 (byte *_3766)
{
switch (_3817 (_3766))
{
case BLOCK_TEXTUAL: return (_3837 (_3766));
case BLOCK_FILE: return (_3843 (_3766));
case BLOCK_NUMERIC: return (_3855 (_3766));
case BLOCK_DATE: return (_3865 (_3766));
case BLOCK_TIME: return (_3871 (_3766));
case BLOCK_TEXTBOX: return (_3880 (_3766));
case BLOCK_BOOLEAN: return (_3884 (_3766));
case BLOCK_SELECT: return (_3892 (_3766));
case BLOCK_RADIO: return (_3900 (_3766));
}
return (NULL);
}
void
form_term (
FORM_ITEM *form)
{
if (form)
{
if (form-> list_values)
sym_delete_table (form-> list_values);
mem_free (form-> data);
mem_free (form);
}
}
void
form_use (
FORM_ITEM *form)
{
ASSERT (form);
_3757 = form;
}
size_t
form_put (
FORM_ITEM *form,
VDESCR *stream,
SYMTAB *symtab)
{
byte
*_3766,
_3928,
*_3929;
int
_3809,
_3930,
_3931,
_3932,
_3933,
_3934,
_3935;
ASSERT (form);
ASSERT (stream);
ASSERT (symtab);
stream-> cur_size = 0;
stream-> data = stream-> data;
form-> status = FSTATUS_OK;
_3809 = -1;
_3931 = 0;
_3930 = 0;
_3766 = form-> defn-> blocks;
_3757 = form;
_3758 = symtab;
_3759 = 0;
sym_assume_symbol (symtab, "_focus", "jsaction");
while (_3930 < form-> defn-> block_count)
{
_3928 = _3817 (_3766);
if (_3913 (_3928))
_3809++;
if (_3931 > 0)
_3931--;
else
if (_3928 == BLOCK_IF)
{
if (_3804 (_3791 (_3824 (_3766), 0)))
_3931 = _3825 (_3766);
}
else
if (_3928 == BLOCK_UNLESS)
{
if (!_3804 (_3791 (_3826 (_3766), 0)))
_3931 = _3827 (_3766);
}
else
if (_3928 == BLOCK_REPEAT)
{
_3932 = atoi (_3791 (_3828 (_3766), 0));
for (_3933 = 0; _3933 < _3932; _3933++)
{
_3934 = _3809;
_3929 = _3766;
for (_3935 = 0;
_3935 < _3829 (_3766);
_3935++)
{
_3929 += _3816 (_3929) + 2;
if (_3913 (_3817 (_3929)))
_3934++;
_3767 (stream, _3929, _3934,
_3933);
}
}
_3931 = _3829 (_3766);
}
else
if (!_3787 (_3809))
_3767 (stream, _3766, _3809, 0);
_3766 += _3816 (_3766) + 2;
_3930++;
}
form-> focus_field = 0;
form-> focus_index = 0;
if (stream-> cur_size >= stream-> max_size)
stream-> cur_size = stream-> max_size - 1;
stream-> data [stream-> cur_size] = '\0';
return (stream-> cur_size);
}
static Bool
_3787 (int _3809)
{
return (_3789 (&_3757-> blank_range, _3809));
}
static Bool
_3789 (RANGE *range, int _3809)
{
if (range-> first == -1)
return (FALSE);
else
if (range-> last == -1)
return (TRUE);
else
return (range-> first <= _3809 &&
_3809 <= range-> last);
}
static void
_3767 (
VDESCR *stream,
byte *_3766,
int _3809,
int index)
{
switch (_3817 (_3766))
{
case BLOCK_PLAIN:
_3772 (stream, _3766);
break;
case BLOCK_COMPRESSED:
_3773 (stream, _3766);
break;
case BLOCK_TEXTUAL:
_3774 (stream, _3766, _3809, index);
break;
case BLOCK_FILE:
_3775 (stream, _3766, _3809, index);
break;
case BLOCK_NUMERIC:
_3776 (stream, _3766, _3809, index);
break;
case BLOCK_DATE:
_3777 (stream, _3766, _3809, index);
break;
case BLOCK_TIME:
_3778 (stream, _3766, _3809, index);
break;
case BLOCK_TEXTBOX:
_3779 (stream, _3766, _3809, index);
break;
case BLOCK_BOOLEAN:
_3780 (stream, _3766, _3809, index);
break;
case BLOCK_SELECT:
_3781 (stream, _3766, _3809, index);
break;
case BLOCK_RLABEL:
_3782 (stream, _3766, _3809, index);
break;
case BLOCK_ACTION:
_3783 (stream, _3766, index);
break;
}
}
static void
_3772 (VDESCR *stream, byte *_3766)
{
_3769 (stream, _3820 (_3766), _3816 (_3766) - 1);
}
static void
_3769 (VDESCR *stream, char *source, int size)
{
static char
_3936 [FORMIO_SYMNAME_MAX + 1];
char
*_3937,
*_3938,
*_3939;
int
_3940;
while (size > 0 && (_3937 = memchr (source, '#', size)) != NULL)
{
if (_3937 > source)
{
_3769 (stream, source, (int) (_3937 - source));
size -= (int) (_3937 - source);
source = _3937;
}
_3938 = memchr (source, ')', size);
if (source [1] == '(' && _3938)
{
_3940 = (int) (_3938 - source - 2);
if (_3940 <= FORMIO_SYMNAME_MAX)
{
memcpy (_3936, source + 2, _3940);
_3936 [_3940] = '\0';
_3939 = sym_get_value (_3758, _3936, "(?)");
_3769 (stream, _3939, strlen (_3939));
}
else
_3769 (stream, source, (int) (_3938 - source) + 1);
size -= (int) (_3938 - source) + 1;
source = _3938 + 1;
}
else
{
if ((stream-> cur_size + 1) < stream-> max_size)
{
memcpy (stream-> data + stream-> cur_size, source, 1);
stream-> cur_size += 1;
}
size--;
source++;
}
}
if ((stream-> cur_size + size) < stream-> max_size)
{
memcpy (stream-> data + stream-> cur_size, source, size);
stream-> cur_size += size;
}
}
static void
_3770 (VDESCR *stream, char *source)
{
_3769 (stream, source, strlen (source));
}
static void
_3773 (VDESCR *stream, byte *_3766)
{
byte
*_3941;
word
block_size;
_3941 = _3822 (_3766) + _3757-> defn-> blocks;
if (_3821 (_3766) == COMPR_WHOLEDICT)
block_size = _3816 (_3941) - 1;
else
if (_3821 (_3766) == COMPR_PARTDICT)
block_size = _3823 (_3766);
else
abort ();
_3769 (stream, _3820 (_3941), block_size);
}
static void
_3774 (VDESCR *stream, byte *_3766, int _3809, int index)
{
char
*value;
_3920
*_3942;
byte
attr;
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
value = _3791 (_3809, index);
if (_3833 (_3766) & _3918)
strupc (value);
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=%s NAME=\"%s\" SIZE=%d MAXLENGTH=%d VALUE=\"",
_3942-> input,
_3792 (_3766, index),
_3834 (_3766),
_3835 (_3766));
if (attr != FATTR_SECURE)
while (*value)
{
if (*value == '<')
_3770 (stream, "&lt;");
else
if (*value == '>')
_3770 (stream, "&gt;");
else
if (*value == '"')
_3770 (stream, "&quot;");
else
_3769 (stream, value, 1);
value++;
}
_3770 (stream, "\">\n");
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
if (!_3942-> _3919)
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
static void
_3786 (byte *block, int field, int index, byte attr)
{
char
*name;
if ((name = _3792 (block, index)) == NULL)
return;
if (attr == FATTR_ERROR
&& _3759 < _3761)
{
_3759 = _3761;
sym_assume_symbol (_3758, "_focus", name);
}
else
if (field == _3757-> focus_field
&& index == _3757-> focus_index
&& _3759 < focus_field)
{
_3759 = focus_field;
sym_assume_symbol (_3758, "_focus", name);
}
else
if (attr != FATTR_HIDDEN
&& _3759 < _3760)
{
_3759 = _3760;
sym_assume_symbol (_3758, "_focus", name);
}
}
static void
_3775 (VDESCR *stream, byte *_3766, int _3809, int index)
{
char
*_3943,
*value,
*_3944;
_3920
*_3942;
byte
attr;
value = _3791 (_3809, index);
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=FILE NAME=\"%s\" SIZE=%d MAXLENGTH=%d VALUE=\"%s\">\n",
_3792 (_3766, index),
_3840 (_3766),
_3841 (_3766),
attr == FATTR_SECURE? "": value);
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION
|| attr == FATTR_LABEL
|| attr == FATTR_HILITE)
{
_3943 = strrchr (value, '/');
if (_3943 == NULL)
_3943 = strrchr (value, '\\');
if (_3943 == NULL)
_3943 = value;
else
_3943++;
_3944 = _3791 (_3809 - 1, index);
_3771 (stream,
"<A HREF=\"/%s\">%s</A>", _3944, _3943);
}
else
if (!_3942-> _3919)
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
static Bool
_3788 (int _3809, int index)
{
if (*_3790 (_3809, index) == FATTR_HIDDEN
|| _3789 (&_3757-> input_range, _3809))
return (TRUE);
else
return (FALSE);
}
static char *
_3792 (byte *_3766, int index)
{
static
char _3945 [LINE_MAX + 8];
switch (_3817 (_3766))
{
case BLOCK_TEXTUAL:
strncpy (_3945, _3836 (_3766), LINE_MAX);
break;
case BLOCK_FILE:
strncpy (_3945, _3842 (_3766), LINE_MAX);
break;
case BLOCK_NUMERIC:
strncpy (_3945, _3854 (_3766), LINE_MAX);
break;
case BLOCK_DATE:
strncpy (_3945, _3864 (_3766), LINE_MAX);
break;
case BLOCK_TIME:
strncpy (_3945, _3870 (_3766), LINE_MAX);
break;
case BLOCK_TEXTBOX:
strncpy (_3945, _3879 (_3766), LINE_MAX);
break;
case BLOCK_BOOLEAN:
strncpy (_3945, _3883 (_3766), LINE_MAX);
break;
case BLOCK_SELECT:
strncpy (_3945, _3891 (_3766), LINE_MAX);
break;
case BLOCK_RADIO:
strncpy (_3945, _3899 (_3766), LINE_MAX);
break;
default:
return (NULL);
}
if (index)
sprintf (_3945 + strlen (_3945), "_%d", index);
return (_3945);
}
static void
_3785 (VDESCR *stream, char *value, int _3809, int index)
{
if (strnull (value))
value = "&lt;Empty&gt;";
if (_3757-> JavaScript)
_3771 (stream,
"<A HREF=\"javascript:submit('~C%d.%d')\">%s</A>\n",
_3809, index, value);
else
_3771 (stream,
"<A HREF=\"#(uri)&~C%d.%d=1\">%s</A>\n",
_3809, index, value);
}
static byte *
_3790 (int _3809, int index)
{
ASSERT (_3809 < _3757-> defn-> field_count);
return (_3757-> data +
_3757-> defn-> fields [_3809].data + index);
}
static char *
_3791 (int _3809, int index)
{
ASSERT (_3809 < _3757-> defn-> field_count);
ASSERT (index < _3819 (_3915 (_3809)));
return (_3914 (_3809)
+ _3819 (_3915 (_3809))
+ (_3916 (_3809) + 1) * index);
}
static Bool
_3804 (char *value)
{
while (*value == '0')
value++;
return (*value == '\0');
}
static void
_3771 (VDESCR *stream, char *format, ...)
{
static char
_3946 [LINE_MAX];
va_list
_3810;
va_start (_3810, format);
#if (defined (DOES_SNPRINTF))
vsnprintf (_3946, LINE_MAX, format, _3810);
#else
vsprintf (_3946, format, _3810);
#endif
va_end (_3810);
_3769 (stream, _3946, strlen (_3946));
}
static void
_3776 (VDESCR *stream, byte *_3766, int _3809, int index)
{
_3920
*_3942;
char
*value;
byte
attr;
int
_3947,
sign_format,
_3948,
_3949;
_3793 (
_3766,
&_3947,
&sign_format,
&_3948,
&_3949);
value = conv_number_str (
_3791 (_3809, index),
_3947,
_3757-> dec_point,
_3848 (_3766),
_3948,
_3949,
sign_format);
if (value == NULL)
value = conv_reason_text [conv_reason];
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=%s NAME=\"%s\" SIZE=%d MAXLENGTH=%d VALUE=\"%s\">\n",
_3942-> input,
_3792 (_3766, index),
_3846 (_3766),
_3847 (_3766),
attr == FATTR_SECURE? "": value);
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
if (!_3942-> _3919)
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
static void
_3793 (byte *_3766, int *flags, int *_3794, int *_3795, int *width)
{
*flags = 0;
switch (_3849 (_3766))
{
case FSIGN_NONE:
*_3794 = 0;
break;
case FSIGN_POST:
*flags += FLAG_N_SIGNED;
*_3794 = SIGN_NEG_TRAIL;
break;
case FSIGN_PRE:
*flags += FLAG_N_SIGNED;
*_3794 = SIGN_NEG_LEAD;
break;
case FSIGN_POSTPLUS:
*flags += FLAG_N_SIGNED;
*_3794 = SIGN_ALL_TRAIL;
break;
case FSIGN_PREPLUS:
*flags += FLAG_N_SIGNED;
*_3794 = SIGN_ALL_LEAD;
break;
case FSIGN_FINANCIAL:
*flags += FLAG_N_SIGNED;
*_3794 = SIGN_FINANCIAL;
break;
}
switch (_3850 (_3766))
{
case FDECFMT_NONE:
*_3795 = 0;
break;
case FDECFMT_ALL:
*flags += FLAG_N_DECIMALS;
*_3795 = DECS_SHOW_ALL;
break;
case FDECFMT_DROP:
*flags += FLAG_N_DECIMALS;
*_3795 = DECS_DROP_ZEROS;
break;
}
switch (_3851 (_3766))
{
case FFILL_NONE:
*width = 0;
break;
case FFILL_SPACE:
*width = _3846 (_3766);
break;
case FFILL_ZERO:
*width = _3846 (_3766);
*flags += FLAG_N_ZERO_FILL;
break;
}
if (_3852 (_3766))
*flags += FLAG_N_ZERO_BLANK;
if (_3853 (_3766))
*flags += FLAG_N_THOUSANDS;
}
static void
_3777 (VDESCR *stream, byte *_3766, int _3809, int index)
{
char
*picture;
int
flags,
format;
long
_3950;
char
*value;
_3920
*_3942;
byte
attr;
_3950 = atol (_3791 (_3809, index));
picture = _3866 (_3766);
if (strused (picture))
value = conv_date_pict (_3950, picture);
else
{
if (_3859 (_3766) == FSHOW_YMD)
if (_3860 (_3766) == FFORMAT_COMPACT)
format = DATE_YMD_COMPACT;
else
if (_3860 (_3766) == FFORMAT_SLASH)
format = DATE_YMD_DELIM;
else
if (_3860 (_3766) == FFORMAT_SPACE)
format = DATE_YMD_SPACE;
else
if (_3860 (_3766) == FFORMAT_COMMA)
format = DATE_YMD_COMMA;
else
format = DATE_YMD_COMPACT;
else
if (_3859 (_3766) == FSHOW_YM)
if (_3860 (_3766) == FFORMAT_COMPACT)
format = DATE_YM_COMPACT;
else
if (_3860 (_3766) == FFORMAT_SLASH)
format = DATE_YM_DELIM;
else
if (_3860 (_3766) == FFORMAT_SPACE)
format = DATE_YM_SPACE;
else
format = DATE_YM_COMPACT;
else
if (_3859 (_3766) == FSHOW_MD)
if (_3860 (_3766) == FFORMAT_COMPACT)
format = DATE_MD_COMPACT;
else
if (_3860 (_3766) == FFORMAT_SLASH)
format = DATE_MD_DELIM;
else
if (_3860 (_3766) == FFORMAT_SPACE)
format = DATE_MD_SPACE;
else
format = DATE_MD_COMPACT;
else
format = DATE_YMD_COMPACT;
flags = 0;
if (_3861(_3766) == FYEAR_FULL)
flags += FLAG_D_CENTURY;
if (_3862 (_3766) == FMONTH_COUNTER)
flags += FLAG_D_MM_AS_M;
else
if (_3862 (_3766) == FMONTH_ALPHA)
flags += FLAG_D_MONTH_ABC;
else
if (_3862 (_3766) == FMONTH_UPPER)
flags += FLAG_D_UPPER;
if (_3863 (_3766) == FDAY_COUNTER)
flags += FLAG_D_DD_AS_D;
value = conv_date_str (_3950, flags, format,
_3757-> date_order,
_3757-> date_sep,
_3858 (_3766));
}
if (value == NULL)
value = conv_reason_text [conv_reason];
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=%s NAME=\"%s\" SIZE=%d MAXLENGTH=%d VALUE=\"%s\">\n",
_3942-> input,
_3792 (_3766, index),
_3858 (_3766),
_3858 (_3766),
attr == FATTR_SECURE? "": value);
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
if (!_3942-> _3919)
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
static void
_3778 (VDESCR *stream, byte *_3766, int _3809, int index)
{
long
_3951;
char
*value;
_3920
*_3942;
byte
attr;
_3951 = atol (_3791 (_3809, index));
value = conv_time_pict (_3951, _3872 (_3766));
if (value == NULL)
value = conv_reason_text [conv_reason];
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=%s NAME=\"%s\" SIZE=%d MAXLENGTH=%d VALUE=\"%s\">\n",
_3942-> input,
_3792 (_3766, index),
_3869 (_3766),
_3869 (_3766),
attr == FATTR_SECURE? "": value);
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
if (!_3942-> _3919)
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
static void
_3779 (VDESCR *stream, byte *_3766, int _3809, int index)
{
_3920
*_3942;
char
*_3952,
*value;
byte
attr;
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
value = (attr == FATTR_SECURE? "": _3791 (_3809, index));
if (_3877 (_3766) & _3918)
strupc (value);
if (_3942-> _3919)
;
else
if (_3942-> input && _3788 (_3809, index))
{
_3786 (_3766, _3809, index, attr);
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<TEXTAREA NAME=\"%s\" ROWS=%d COLS=%d MAXLENGTH=%d WRAP=\"%s\">",
_3792 (_3766, index),
_3875 (_3766),
_3876 (_3766),
_3878 (_3766),
"VIRTUAL");
while (*value)
{
if (*value == '<')
_3770 (stream, "&lt;");
else
if (*value == '>')
_3770 (stream, "&gt;");
else
_3769 (stream, value, 1);
value++;
}
_3770 (stream, "</TEXTAREA>\n");
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
{
_3952 = _3942-> output;
while (*_3952)
{
if (*_3952 == '%')
{
_3952 += 2;
break;
}
_3769 (stream, _3952, 1);
_3952++;
}
if (*value)
while (*value)
{
if (*value == '\n')
_3770 (stream, "<BR>");
else
_3769 (stream, value, 1);
value++;
}
else
_3770 (stream, "&nbsp;");
while (*_3952)
_3769 (stream, _3952++, 1);
}
}
static void
_3780 (VDESCR *stream, byte *_3766, int _3809, int index)
{
_3920
*_3942;
char
*value;
byte
attr;
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> _3919)
;
else
if (_3942-> input && _3788 (_3809, index))
{
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream,
"<INPUT TYPE=CHECKBOX %sNAME=\"%s\">\n",
_3791 (_3809, index) [0] == '1'? "CHECKED ": "",
_3792 (_3766, index));
if (_3942-> error)
_3770 (stream, _3763);
}
else
{
value = _3791 (_3809, index) [0] == '1'?
_3885 (_3766): _3886 (_3766);
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
}
static void
_3781 (VDESCR *stream, byte *_3766, int _3809, int index)
{
_3920
*_3942;
int
_3953,
_3954,
_3955;
char
*value,
*_3956;
byte
attr;
_3955 = atoi (_3791 (_3809, index));
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> _3919)
;
else
if (_3942-> input && _3788 (_3809, index))
{
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream, "<SELECT NAME=\"%s\" SIZE=%d>\n",
_3792 (_3766, index),
_3889 (_3766));
if (_3890 (_3766) == 0)
{
_3954 = fxlist_size (_3809, index);
for (_3953 = 1; _3953 <= _3954; _3953++)
_3771 (stream, "<OPTION VALUE=\"%d\"%s>%s\n", _3953,
_3953 == _3955? " SELECTED": "",
_3805 (_3809, index, _3953, 'v'));
}
else
{
_3771 (stream, "<OPTION VALUE=\"0\"%s>%s\n",
_3955 == 0? " SELECTED": "",
_3893 (_3766));
_3956 = _3894 (_3766);
for (_3953 = 1; _3953 <= _3890 (_3766); _3953++)
{
_3771 (stream, "<OPTION VALUE=\"%d\"%s>%s\n", _3953,
_3953 == _3955? " SELECTED": "",
_3956);
_3956 += strlen (_3956) + 1;
}
}
_3770 (stream, "</SELECT>\n");
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (_3955 == 0)
_3771 (stream, _3942-> output, _3893 (_3766));
else
{
if (_3890 (_3766) == 0)
value = _3805 (_3809, index, _3955, 'v');
else
{
_3956 = _3893 (_3766);
for (_3953 = 0; _3953 < _3955; _3953++)
_3956 += strlen (_3956) + 1;
value = _3956;
}
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
_3771 (stream, _3942-> output, *value? value: "&nbsp;");
}
}
static void
_3782 (VDESCR *stream, byte *_3766, int _3809, int index)
{
_3920
*_3942;
int
_3957;
byte
*_3958;
char
*value;
byte
attr;
_3957 = atoi (_3791 (_3809, index));
_3958 = _3757-> defn-> blocks + _3902 (_3766);
attr = *_3790 (_3809, index);
_3942 = &_3921 [attr];
if (_3942-> _3919)
;
else
if (_3942-> input && _3788 (_3809, index))
{
if (_3903 (_3766) > 1 && _3898 (_3958))
_3770 (stream, "<BR>");
if (_3942-> error)
_3770 (stream, _3762);
_3771 (stream, "<INPUT TYPE=RADIO VALUE=\"%d\" NAME=\"%s\"%s>%s\n",
_3903 (_3766),
_3792 (_3958, index),
_3903 (_3766) == _3957? " CHECKED": "",
_3904 (_3766));
if (_3942-> error)
_3770 (stream, _3763);
}
else
if (_3897 (_3958))
{
if (_3903 (_3766) > 1 && _3898 (_3958))
_3770 (stream, "<BR>");
value = xstrcpy (NULL,
_3903 (_3766) == _3957?
" (*) ": " (&nbsp;) ",
_3904 (_3766),
NULL);
if (attr == FATTR_OPTION)
_3785 (stream, value, _3809, index);
else
_3771 (stream, _3942-> output, value);
mem_free (value);
}
else
if (_3957 == 0 && _3903 (_3766) == 1)
{
if (attr == FATTR_OPTION)
_3785 (stream, _3901 (_3958), _3809, index);
else
_3771 (stream, _3942-> output, _3901 (_3958));
}
else
if (_3903 (_3766) == _3957)
{
if (attr == FATTR_OPTION)
_3785 (stream, _3904 (_3766), _3809, index);
else
_3771 (stream, _3942-> output, _3904 (_3766));
}
}
static void
_3783 (VDESCR *stream, byte *_3766, int index)
{
char
*_3959;
if (*_3917 (_3766) == FACTION_ENABLED)
{
if (_3905 (_3766) == FTYPE_BUTTON)
_3771 (stream, "<INPUT TYPE=SUBMIT VALUE=\"%s\" NAME=\"%s\">\n",
_3912 (_3766), _3911 (_3766));
else
if (_3905 (_3766) == FTYPE_PLAIN)
{
if (_3757-> JavaScript)
_3771 (stream,
"<A HREF=\"javascript:submit('~A%d.%d')\">%s</A>\n",
_3906 (_3766), index,
_3912 (_3766));
else
_3771 (stream, "<A HREF=\"#(uri)&~A%d.%d=1\">%s</A>\n",
_3906 (_3766), index,
_3912 (_3766));
}
else
if (_3905 (_3766) == FTYPE_IMAGE)
{
if (_3757-> JavaScript)
{
_3959 = mem_strdup (_3911 (_3766));
_3959 [0] = toupper (_3959 [0]);
_3771   (stream, "<A HREF=\"javascript:submit('~A%d.%d')\"",
_3906 (_3766), index);
_3771   (stream, " TITLE=\"%s\">", _3959);
_3784 (stream, _3766);
_3771   (stream, "</A>");
mem_free (_3959);
}
else
{
_3771 (stream,
"<INPUT TYPE=IMAGE BORDER=0 SRC=\"%s\" NAME=\"%s\"",
_3912 (_3766), _3911 (_3766));
if (_3909 (_3766))
_3771 (stream, " HEIGHT=%d WIDTH=%d",
_3909 (_3766),
_3910 (_3766));
_3771 (stream, ">");
}
}
}
else
if (*_3917 (_3766) == FACTION_DISABLED)
{
if (_3905 (_3766) == FTYPE_BUTTON)
_3771 (stream, "&nbsp;[ %s ]&nbsp;\n", _3912 (_3766));
else
if (_3905 (_3766) == FTYPE_PLAIN)
_3771 (stream, "%s\n", _3912 (_3766));
else
if (_3905 (_3766) == FTYPE_IMAGE)
_3784 (stream, _3766);
}
}
static void
_3784 (VDESCR *stream, byte *_3766)
{
char
*_3959;
_3959 = mem_strdup (_3911 (_3766));
_3959 [0] = toupper (_3959 [0]);
_3771 (stream, "<IMG BORDER=0 SRC=\"%s\" ALT=\"%s\" ALIGN=MIDDLE",
_3912 (_3766), _3959);
if (_3909 (_3766))
_3771 (stream, " HEIGHT=%d WIDTH=%d",
_3909 (_3766), _3910 (_3766));
_3771 (stream, ">");
mem_free (_3959);
}
int
form_get (
FORM_ITEM *form,
const char *query)
{
SYMTAB
*symtab;
int
_3960 = 0;
ASSERT (form);
ASSERT (query);
if ((symtab = http_query2symb (query)) == NULL)
return 0;
form-> status = FSTATUS_OK;
form-> image_x = 0;
form-> image_y = 0;
form-> click_field = 0;
form-> click_index = 0;
strclr (form-> livelink);
form-> event = form-> click_event;
mem_check (form-> data);
form_use (form);
if (*query == '&' || *query == '~')
sym_exec_all (symtab, _3814);
else
{
form_exec (form, _3811, symtab, &_3960);
_3815 (symtab);
}
sym_delete_table (symtab);
return (form-> status == FSTATUS_OK? _3960: -1);
}
static Bool
_3811 (
FORM_ITEM *form,
byte *_3766,
int _3809,
va_list _3810)
{
static int
_3961,
_3962 = 0;
SYMTAB
*symtab;
SYMBOL
*symbol;
byte
_3928;
int
_3963,
*_3964,
_3965,
index;
symtab = va_arg (_3810, SYMTAB *);
_3964 = va_arg (_3810, int *);
if (_3809 == -1)
_3961 = 0;
mem_check (form-> data);
_3928 = _3817 (_3766);
if (_3913 (_3928))
{
_3965 = _3961? _3962: 1;
for (index = 0; index < _3965; index++)
{
if (_3928 == BLOCK_BOOLEAN)
strcpy (_3791 (_3809, index), "0");
_3797 (_3809, index);
symbol = sym_lookup_symbol (symtab, _3792 (_3766, index));
if (symbol)
{
_3963 = _3796 (_3766, _3809, index,
symbol-> value);
if (_3963 == -1)
form-> status = FSTATUS_FIELD;
else
*_3964 += _3963;
}
}
}
else
if (_3928 == BLOCK_ACTION)
_3803 (symtab, _3766);
else
if (_3928 == BLOCK_REPEAT)
{
_3961 = _3829 (_3766) + 1;
_3962 = atoi (_3791 (_3828 (_3766), 0));
}
if (_3961)
_3961--;
return (TRUE);
}
static int
_3796 (byte *_3766, int _3809, int index, char *value)
{
switch (_3817 (_3766))
{
case BLOCK_TEXTUAL:
return (_3798 (_3766, _3809, index, value));
case BLOCK_TEXTBOX:
return (_3799 (_3766, _3809, index, value));
case BLOCK_SELECT:
case BLOCK_RADIO:
case BLOCK_FILE:
return (fxputn_text (_3809, index, value));
case BLOCK_NUMERIC:
return (_3800 (_3766, _3809, index, value));
case BLOCK_DATE:
return (_3801 (_3766, _3809, index, value));
case BLOCK_TIME:
return (_3802 (_3766, _3809, index, value));
case BLOCK_BOOLEAN:
return (fxputn_text (_3809, index, "1"));
}
return (0);
}
static int
_3798 (byte *_3766, int _3809, int index, char *value)
{
if (_3833 (_3766) & _3918)
strupc (value);
return (fxputn_text (_3809, index, value));
}
static int
_3799 (byte *_3766, int _3809, int index, char *value)
{
if (_3877 (_3766) & _3918)
strupc (value);
return (fxputn_text (_3809, index, value));
}
static int
_3800 (byte *_3766, int _3809, int index, char *value)
{
static char
_3966 [LINE_MAX];
int
_3947,
sign_format,
_3948,
_3967;
char
*_3968;
byte
*attr;
_3793 (
_3766,
&_3947,
&sign_format,
&_3948,
&_3967);
_3967 = _3846 (_3766);
_3968 = conv_str_number
(
value,
_3947,
_3757-> dec_point,
_3848 (_3766),
_3948,
_3967
);
if (_3968 == NULL)
{
xstrcpy (_3966, "Invalid number (", value, "): ",
conv_reason_text [conv_reason], NULL);
form_strerror = _3966;
attr = _3790 (_3809, index);
if (*attr == FATTR_INPUT)
*attr = FATTR_ERROR;
return (-1);
}
else
return (fxputn_text (_3809, index, _3968));
}
static int
_3801 (byte *_3766, int _3809, int index, char *value)
{
static char
_3969 [LINE_MAX];
int
format;
long
_3950 = -1;
byte
*attr;
if (_3859 (_3766) == FSHOW_YMD)
format = DATE_YMD_DELIM;
else
if (_3859 (_3766) == FSHOW_YM)
format = DATE_YM_DELIM;
else
format = DATE_MD_DELIM;
_3950 = conv_str_date (value, 0, format, _3757-> date_order);
if (_3950 == -1)
{
xstrcpy (_3969, "Invalid date (", value, "): ",
conv_reason_text [conv_reason], NULL);
form_strerror = _3969;
attr = _3790 (_3809, index);
if (*attr == FATTR_INPUT)
*attr = FATTR_ERROR;
return (-1);
}
else
return (fxputn_date (_3809, index, _3950));
}
static int
_3802 (byte *_3766, int _3809, int index, char *value)
{
static char
_3970 [LINE_MAX];
long
_3951 = -1;
byte
*attr;
_3951 = conv_str_time (value);
if (_3951 == -1)
{
xstrcpy (_3970, "Invalid time (", value, "): ",
conv_reason_text [conv_reason], NULL);
form_strerror = _3970;
attr = _3790 (_3809, index);
if (*attr == FATTR_INPUT)
*attr = FATTR_ERROR;
return (-1);
}
else
return (fxputn_time (_3809, index, _3951));
}
static void
_3797 (int _3809, int index)
{
byte
*attr;
attr = _3790 (_3809, index);
if (*attr == FATTR_ERROR)
*attr = FATTR_INPUT;
}
static void
_3803 (SYMTAB *symtab, byte *_3766)
{
SYMBOL
*symbol;
char
*_3971;
if (_3905 (_3766) == FTYPE_IMAGE)
{
_3971 = xstrcpy (NULL, _3911 (_3766), ".x", NULL);
symbol = sym_lookup_symbol (symtab, _3971);
if (symbol)
{
_3757-> event = _3906 (_3766);
_3757-> image_x = atoi (symbol-> value);
strlast (_3971) = 'y';
symbol = sym_lookup_symbol (symtab, _3971);
if (symbol)
_3757-> image_y = atoi (symbol-> value);
}
mem_free (_3971);
}
else
{
symbol = sym_lookup_symbol (symtab, _3911 (_3766));
if (symbol)
_3757-> event = _3906 (_3766);
}
}
static Bool
_3814 (SYMBOL *symbol, ...)
{
char
*_3972;
if (symbol-> name [0] == '~')
{
_3972 = strchr (symbol-> name + 2, '.');
if (_3972)
_3757-> click_index = atoi (_3972 + 1);
if (symbol-> name [1] == 'C')
{
_3757-> click_field = atoi (symbol-> name + 2);
_3757-> event = _3757-> click_event;
return (FALSE);
}
else
if (symbol-> name [1] == 'A')
{
_3757-> event = atoi (symbol-> name + 2);
return (FALSE);
}
else
if (symbol-> name [1] == 'L')
{
strncpy (_3757-> livelink, symbol-> name + 2,
FORMIO_LIVELINK_MAX);
_3757-> livelink [FORMIO_LIVELINK_MAX] = '\0';
_3757-> event = _3757-> click_event;
return (FALSE);
}
}
return (TRUE);
}
static void
_3815 (SYMTAB *symtab)
{
SYMBOL
*symbol;
char
*_3972;
symbol = sym_lookup_symbol (symtab, "jsaction");
if (symbol && symbol-> value [0] == '~')
{
_3972 = strchr (symbol-> value + 2, '.');
if (_3972)
_3757-> click_index = atoi (_3972 + 1);
if (symbol-> value [1] == 'C')
{
_3757-> click_field = atoi (symbol-> value + 2);
_3757-> event = _3757-> click_event;
}
else
if (symbol-> value [1] == 'A')
_3757-> event = atoi (symbol-> value + 2);
else
if (symbol-> value [1] == 'L')
{
strncpy (_3757-> livelink, symbol-> value + 2,
FORMIO_LIVELINK_MAX);
_3757-> livelink [FORMIO_LIVELINK_MAX] = '\0';
_3757-> event = _3757-> click_event;
}
}
}
int
fxputn_text (int field, int index, const char *new_value)
{
char
*value;
ASSERT (new_value);
ASSERT (index < _3819 (_3915 (field)));
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
value = _3791 (field, index);
if (streq (value, new_value))
return (0);
else
{
strncpy (value, new_value, _3916 (field));
value [_3916 (field)] = '\0';
strcrop (value);
return (1);
}
}
int
fxputn_char (int field, int index, char new_value)
{
char
_3973 [2] = {0, 0};
ASSERT (index < _3819 (_3915 (field)));
_3973 [0] = new_value;
return (fxputn_text (field, index, _3973));
}
int
fxputn_date (int field, int index, long new_value)
{
ASSERT (index < _3819 (_3915 (field)));
return (fxputn_long (field, index, new_value));
}
int
fxputn_time (int field, int index, long new_value)
{
ASSERT (index < _3819 (_3915 (field)));
return (fxputn_long (field, index, new_value));
}
int
fxputn_int (int field, int index, int new_value)
{
ASSERT (index < _3819 (_3915 (field)));
return (fxputn_long (field, index, (long) new_value));
}
int
fxputn_long (int field, int index, long new_value)
{
static char
_3946 [20];
ASSERT (index < _3819 (_3915 (field)));
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
sprintf (_3946, "%ld", new_value);
return (fxputn_text (field, index, _3946));
}
int
fxputn_double (int field, int index, double new_value)
{
static char
_3946 [40],
format [10];
ASSERT (index < _3819 (_3915 (field)));
sprintf (format, "%%.%df", _3848 (_3915 (field)));
sprintf (_3946, format, new_value);
return (fxputn_text (field, index, _3946));
}
int
fxputn_bool (int field, int index, Bool new_value)
{
ASSERT (index < _3819 (_3915 (field)));
return (fxputn_text (field, index, new_value? "1": "0"));
}
char *
fxgetn_text (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (NULL);
ASSERT (index < _3819 (_3915 (field)));
return (_3791 (field, index));
}
char
fxgetn_char (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
return (*_3791 (field, index));
}
long
fxgetn_date (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
ASSERT (_3817 (_3915 (field)) == BLOCK_DATE);
return (atol (_3791 (field, index)));
}
long
fxgetn_time (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
ASSERT (_3817 (_3915 (field)) == BLOCK_TIME);
return (atol (_3791 (field, index)));
}
int
fxgetn_int (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
return (atoi (_3791 (field, index)));
}
long
fxgetn_long (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
return (atol (_3791 (field, index)));
}
double
fxgetn_double (int field, int index)
{
if (field < 0 || field >= _3757-> defn-> field_count)
return (0);
ASSERT (index < _3819 (_3915 (field)));
return (atof (_3791 (field, index)));
}
Bool
fxgetn_bool (int field, int index)
{
ASSERT (index < _3819 (_3915 (field)));
return (fxgetn_long (field, index)? TRUE: FALSE);
}
byte
fxattr_get (
int _3809,
int index)
{
FORM_DEFN
*defn;
defn = _3757-> defn;
ASSERT (_3809 >= 0 && _3809 < defn-> field_count);
return (*_3790 (_3809, index));
}
void
fxattr_put (
int _3809,
int index,
byte attr)
{
FORM_DEFN
*defn;
defn = _3757-> defn;
ASSERT (_3809 >= 0 && _3809 < defn-> field_count);
*_3790 (_3809, index) = attr;
}
size_t
fxlist_size (int field, int index)
{
return (atoi (_3805 (field, index, 0, 'h')));
}
static char *
_3807 (int field, int index, int item, char _3806)
{
static char
key [11];
sprintf (key, "%02x.%02x.%02x.%c",
(byte) field, (byte) index, (byte) item, _3806);
return (key);
}
static char *
_3805 (int field, int index, int item, char _3806)
{
SYMBOL
*symbol;
if (_3757-> list_values)
{
symbol = sym_lookup_symbol (_3757-> list_values,
_3807 (field, index, item, _3806));
if (symbol)
return (symbol-> value);
}
return ("");
}
void
fxlist_reset (int field, int index)
{
SYMBOL
*symbol;
int
item;
if (_3757-> list_values == NULL)
_3757-> list_values = sym_create_table ();
item = fxlist_size (field, index);
while (item > 0)
{
symbol = sym_lookup_symbol (_3757-> list_values,
_3807 (field, index, item, 'k'));
if (symbol)
sym_delete_symbol (_3757-> list_values, symbol);
symbol = sym_lookup_symbol (_3757-> list_values,
_3807 (field, index, item, 'v'));
if (symbol)
sym_delete_symbol (_3757-> list_values, symbol);
item--;
}
sym_create_symbol (_3757-> list_values,
_3807 (field, index, 0, 'h'), "000");
}
int
fxlist_append (int field, int index, char *key, char *value)
{
SYMBOL
*symbol;
int
_3974;
ASSERT (_3757-> list_values);
symbol = sym_lookup_symbol (_3757-> list_values,
_3807 (field, index, 0, 'h'));
if (symbol == NULL)
return (0);
_3974 = fxlist_size (field, index);
if (_3974 == 999)
return (_3974);
_3974++;
sym_assume_symbol (_3757-> list_values,
_3807 (field, index, _3974, 'k'), key);
sym_assume_symbol (_3757-> list_values,
_3807 (field, index, _3974, 'v'), value);
sprintf (symbol-> value, "%d", _3974);
return (_3974);
}
char *
fxlist_key (int field, int index)
{
return (_3805 (field, index, fxgetn_int (field, index), 'k'));
}
char *
fxlist_value (int field, int index)
{
return (_3805 (field, index, fxgetn_int (field, index), 'v'));
}
void
fxlist_set (int field, int index, char *key)
{
int
item;
ASSERT (_3757-> list_values);
item = fxlist_size (field, index);
while (item > 0)
{
if (streq (_3805 (field, index, item, 'k'), key))
break;
item--;
}
fxputn_int (field, index, item);
}
int
form_exec (
FORM_ITEM *form,
blockfunc _3975,
...)
{
va_list
_3810;
byte
*_3766;
word
block_size;
int
_3809,
_3930,
count = 0;
ASSERT (form);
va_start (_3810, _3975);
_3809 = -1;
_3766 = form-> defn-> blocks;
for (_3930 = 0; _3930 < form-> defn-> block_count; _3930++)
{
block_size = _3816 (_3766);
ASSERT (block_size > 0);
if (_3913 (_3817 (_3766)))
_3809++;
if ((*_3975) (form, _3766, _3809, _3810))
count++;
else
break;
_3766 += block_size + 2;
}
va_end (_3810);
return (count);
}
void
action_enable (FORM_ITEM *form, int event)
{
form_exec (form, _3813, event, FACTION_ENABLED);
}
static Bool
_3813 (
FORM_ITEM *form,
byte *_3766,
int _3809,
va_list _3810)
{
int
event,
attr;
event = va_arg (_3810, int);
attr = va_arg (_3810, int);
_3757 = form;
if (_3817 (_3766) == BLOCK_ACTION)
{
if (event == -1
|| event == _3906 (_3766))
*_3917 (_3766) = attr;
}
return (TRUE);
}
void
action_disable (FORM_ITEM *form, int event)
{
form_exec (form, _3813, event, FACTION_DISABLED);
}
void
action_hide (FORM_ITEM *form, int event)
{
form_exec (form, _3813, event, FACTION_HIDDEN);
}
int
form_save (
const char *filename,
FORM_ITEM *form)
{
FILE
*stream;
stream = fopen (filename, FOPEN_WRITE_BINARY);
if (stream)
{
fwrite (form, sizeof (FORM_ITEM), 1, stream);
fwrite (form-> data, form-> data_size, 1, stream);
fclose (stream);
return (0);
}
else
return (-1);
}
FORM_ITEM *
form_load (
const char *filename,
FORM_DEFN *defn)
{
FILE
*stream;
FORM_ITEM
*form;
byte
*data;
stream = fopen (filename, FOPEN_READ_BINARY);
if (!stream)
return (NULL);
if ((form = _3764 (defn)) == NULL)
return (NULL);
data = form-> data;
fread (form, sizeof (FORM_ITEM), 1, stream);
form-> data = data;
form-> defn = defn;
fread (form-> data, form-> data_size, 1, stream);
mem_check (form-> data);
fclose (stream);
return (form);
}
void
form_dump (FORM_ITEM *form)
{
int
_3930 = 0;
ASSERT (form);
printf ("Dumping contents of form %s\n", form-> defn-> form_name);
printf ("Block: Size:  Type:      Details:\n");
form_exec (form, _3812, &_3930);
}
static Bool
_3812 (
FORM_ITEM *form,
byte *_3766,
int _3809,
va_list _3810)
{
byte
*_3941;
word
block_size;
int
*_3930;
_3930 = va_arg (_3810, int *);
block_size = _3816 (_3766);
printf ("%p %-6d %-6d ", _3766, *_3930, block_size);
(*_3930)++;
switch (_3817 (_3766))
{
case BLOCK_PLAIN:
printf ("plain      ");
_3766 += 2;
block_size--;
if (block_size > 50)
block_size = 50;
while (block_size-- > 0)
printf ("%c", *++_3766);
printf ("\n");
break;
case BLOCK_COMPRESSED:
printf ("compressed ");
_3941 = _3822 (_3766) + form-> defn-> blocks;
if (_3821 (_3766) == COMPR_WHOLEDICT)
block_size = _3816 (_3941) - 1;
else
if (_3821 (_3766) == COMPR_PARTDICT)
block_size = _3823 (_3766);
else
abort ();
_3941 += 2;
if (block_size > 50)
block_size = 50;
while (block_size-- > 0)
printf ("%c", *++_3941);
printf ("\n");
break;
case BLOCK_IF:
printf ("if         ");
printf ("field=%d scope=%d\n",
_3824 (_3766),
_3825 (_3766));
break;
case BLOCK_UNLESS:
printf ("unless     ");
printf ("field=%d scope=%d\n",
_3826 (_3766),
_3827 (_3766));
break;
case BLOCK_REPEAT:
printf ("repeat     ");
printf ("field=%d scope=%d occurs=%d\n",
_3828 (_3766),
_3829 (_3766),
_3830 (_3766));
break;
case BLOCK_TEXTUAL:
printf ("textual    ");
printf ("x%d attr=%d size=%d max=%d name=%s value=%s\n",
_3832 (_3766),
_3831 (_3766),
_3834 (_3766),
_3835 (_3766),
_3836 (_3766),
_3837 (_3766));
break;
case BLOCK_FILE:
printf ("file       ");
printf ("x%d attr=%d size=%d max=%d name=%s value=%s\n",
_3839 (_3766),
_3838 (_3766),
_3840 (_3766),
_3841 (_3766),
_3842 (_3766),
_3843 (_3766));
break;
case BLOCK_NUMERIC:
printf ("numeric    ");
printf ("x%d attr=%d size=%d max=%d sign=%d decs=%d ",
_3845 (_3766),
_3844 (_3766),
_3846 (_3766),
_3847 (_3766),
_3849 (_3766),
_3848 (_3766));
printf ("fill=%d blank=%d comma=%d name=%s value=%s\n",
_3851 (_3766),
_3852 (_3766),
_3853 (_3766),
_3854 (_3766),
_3855 (_3766));
break;
case BLOCK_DATE:
printf ("date       ");
printf ("x%d attr=%d size=%d show=%d format=%d year=%d ",
_3857 (_3766),
_3856 (_3766),
_3858 (_3766),
_3859 (_3766),
_3860 (_3766),
_3861 (_3766));
printf ("month=%d day=%d name=%s value=%s picture=%s\n",
_3862 (_3766),
_3863 (_3766),
_3864 (_3766),
_3865 (_3766),
_3866 (_3766));
break;
case BLOCK_TIME:
printf ("time       ");
printf ("x%d attr=%d size=%d name=%s value=%s picture=%s\n",
_3868 (_3766),
_3867 (_3766),
_3869 (_3766),
_3870 (_3766),
_3871 (_3766),
_3872 (_3766));
break;
case BLOCK_TEXTBOX:
printf ("textbox    ");
printf ("x%d attr=%d rows=%d cols=%d max=%d name=%s value=%s\n",
_3874 (_3766),
_3873 (_3766),
_3875 (_3766),
_3876 (_3766),
_3878 (_3766),
_3879 (_3766),
_3880 (_3766));
break;
case BLOCK_BOOLEAN:
printf ("boolean    ");
printf ("x%d attr=%d name=%s value=%s\n",
_3882 (_3766),
_3881 (_3766),
_3883 (_3766),
_3884 (_3766));
break;
case BLOCK_SELECT:
printf ("select     ");
printf ("x%d attr=%d size=%d opts=%d name=%s value=%s first=%s\n",
_3888 (_3766),
_3887 (_3766),
_3889 (_3766),
_3890 (_3766),
_3891 (_3766),
_3892 (_3766),
_3894 (_3766));
break;
case BLOCK_RADIO:
printf ("radio      ");
printf ("x%d attr=%d detail=%d column=%d name=%s value=%s\n",
_3896 (_3766),
_3895 (_3766),
_3897 (_3766),
_3898 (_3766),
_3899 (_3766),
_3900 (_3766));
break;
case BLOCK_RLABEL:
printf ("rlabel     ");
printf ("data=%d index=%d value=%s\n",
_3902 (_3766),
_3903 (_3766),
_3904 (_3766));
break;
case BLOCK_ACTION:
printf ("action     ");
printf ("type=%d event=%d show=%d height=%d width=%d label=%s\n",
_3905 (_3766),
_3906 (_3766),
_3908 (_3766),
_3909 (_3766),
_3910 (_3766),
_3912 (_3766));
break;
default:
printf ("ERROR!\n");
abort ();
}
return (TRUE);
}
int
form_ftype (
FORM_ITEM *form,
int _3809)
{
FORM_DEFN
*defn;
ASSERT (form);
defn = form-> defn;
if (_3809 < 0 || _3809 >= defn-> field_count)
return (0);
else
return (_3817 (defn-> blocks + defn-> fields [_3809].block));
}
